Index: /trunk/SophyaExt/XephemAstroLib/marsmoon.c
===================================================================
--- /trunk/SophyaExt/XephemAstroLib/marsmoon.c	(revision 2551)
+++ /trunk/SophyaExt/XephemAstroLib/marsmoon.c	(revision 2551)
@@ -0,0 +1,213 @@
+/* mars moon info */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <math.h>
+
+#include "astro.h"
+#include "bdl.h"
+
+static int use_bdl (double JD, char *dir, MoonData md[M_NMOONS]);
+static void moonradec (double msize, MoonData md[M_NMOONS]);
+static void moonSVis (Obj *eop, Obj *mop, MoonData md[M_NMOONS]);
+static void moonEVis (MoonData md[M_NMOONS]);
+
+/* moon table and a few other goodies and when it was last computed */
+static double mdmjd = -123456;
+static MoonData mmd[M_NMOONS] = {
+    {"Mars", NULL},
+    {"Phobos", "I"},
+    {"Deimos", "II"},
+};
+static double sizemjd;
+
+/* file containing BDL coefficients */
+static char mbdlfn[] = "mars.9910";
+
+/* get mars info in md[0], moon info in md[1..M_NMOONS-1].
+ * if !dir always use bruton model.
+ * if !mop caller just wants md[] for names
+ * N.B. we assume eop and mop are updated.
+ */
+void
+marsm_data (
+double Mjd,			/* mjd */
+char dir[],			/* dir in which to look for helper files */
+Obj *eop,			/* earth == Sun */
+Obj *mop,			/* mars */
+double *sizep,			/* mars's angular diam, rads */
+MoonData md[M_NMOONS])		/* return info */
+{
+	double JD, dmag;
+
+	/* always copy back at least for name */
+	memcpy (md, mmd, sizeof(mmd));
+
+	/* nothing else if repeat call or just want names */
+	if (Mjd == mdmjd || !mop) {
+	    if (mop) {
+		*sizep = sizemjd;
+	    }
+	    return;
+	}
+	JD = Mjd + MJD0;
+
+	/* planet in [0] */
+	md[0].ra = mop->s_ra;
+	md[0].dec = mop->s_dec;
+	md[0].mag = get_mag(mop);
+	md[0].x = 0;
+	md[0].y = 0;
+	md[0].z = 0;
+	md[0].evis = 1;
+	md[0].svis = 1;
+
+	/* size is straight from mop */
+	*sizep = degrad(mop->s_size/3600.0);
+
+	/* from Pasachoff/Menzel: brightest @ .6 AU */
+	dmag = 5.0*log10(mop->s_edist + 0.4);
+	md[1].mag = 11.8 + dmag;
+	md[2].mag = 12.9 + dmag;
+
+	/* get moon x,y,z from BDL if possible */
+	if (dir && use_bdl (JD, dir, md) < 0) {
+	    int i;
+	    for (i = 1; i < M_NMOONS; i++)
+		md[i].x = md[i].y = md[i].z = 0.0;
+	    fprintf (stderr, "No mars model available\n");
+	}
+
+	/* set visibilities */
+	moonSVis (eop, mop, md);
+	moonEVis (md);
+
+	/* fill in moon ra and dec */
+	moonradec (*sizep, md);
+
+	/* save */
+	mdmjd = Mjd;
+	sizemjd = *sizep;
+	memcpy (mmd, md, sizeof(mmd));
+}
+
+/* hunt for BDL file in dir[] and use if possible.
+ * return 0 if ok, else -1
+ */
+static int
+use_bdl (
+double JD,		/* julian date */
+char dir[],		/* directory */
+MoonData md[M_NMOONS])	/* fill md[1..NM-1].x/y/z for each moon */
+{
+#define MRAU    .00002269       /* Mars radius, AU */
+	double x[M_NMOONS], y[M_NMOONS], z[M_NMOONS];
+	char buf[1024];
+	FILE *fp;
+	int i;
+
+	/* only valid 1999 through 2010 */
+	if (JD < 2451179.50000 || JD >= 2455562.5)
+	    return (-1);
+
+	/* open */
+	(void) sprintf (buf, "%s/%s", dir, mbdlfn);
+	fp = fopen (buf, "r");
+	if (!fp)
+	    return (-1);
+
+	/* use it */
+	if ((i = read_bdl (fp, JD, x, y, z, buf)) < 0) {
+	    fprintf (stderr, "%s: %s\n", mbdlfn, buf);
+	    fclose (fp);
+	    return (-1);
+	}
+	if (i != M_NMOONS-1) {
+	    fprintf (stderr, "%s: BDL says %d moons, code expects %d", mbdlfn,
+								i, M_NMOONS-1);
+	    fclose (fp);
+	    return (-1);
+	}
+
+	/* copy into md[1..NM-1] with our scale and sign conventions */
+	for (i = 1; i < M_NMOONS; i++) {
+	    md[i].x =  x[i-1]/MRAU;	/* we want mars radii +E */
+	    md[i].y = -y[i-1]/MRAU;	/* we want mars radii +S */
+	    md[i].z = -z[i-1]/MRAU;	/* we want mars radii +front */
+	}
+
+	/* ok */
+	fclose (fp);
+	return (0);
+}
+
+/* given mars loc in md[0].ra/dec and size, and location of each moon in 
+ * md[1..NM-1].x/y in mars radii,find ra/dec of each moon in md[1..NM-1].ra/dec.
+ */
+static void
+moonradec (
+double msize,		/* mars diameter, rads */
+MoonData md[M_NMOONS])	/* fill in RA and Dec */
+{
+	double mrad = msize/2;
+	double mra = md[0].ra;
+	double mdec = md[0].dec;
+	int i;
+
+	for (i = 1; i < M_NMOONS; i++) {
+	    double dra  = mrad * md[i].x;
+	    double ddec = mrad * md[i].y;
+	    md[i].ra  = mra + dra;
+	    md[i].dec = mdec - ddec;
+	}
+}
+
+/* set svis according to whether moon is in sun light */
+static void
+moonSVis(
+Obj *eop,		/* earth == SUN */
+Obj *mop,		/* mars */
+MoonData md[M_NMOONS])
+{
+	double esd = eop->s_edist;
+	double eod = mop->s_edist;
+	double sod = mop->s_sdist;
+	double soa = degrad(mop->s_elong);
+	double esa = asin(esd*sin(soa)/sod);
+	double   h = sod*mop->s_hlat;
+	double nod = h*(1./eod - 1./sod);
+	double sca = cos(esa), ssa = sin(esa);
+	int i;
+
+	for (i = 1; i < M_NMOONS; i++) {
+	    MoonData *mdp = &md[i];
+	    double xp =  sca*mdp->x + ssa*mdp->z;
+	    double yp =  mdp->y;
+	    double zp = -ssa*mdp->x + sca*mdp->z;
+	    double ca = cos(nod), sa = sin(nod);
+	    double xpp = xp;
+	    double ypp = ca*yp - sa*zp;
+	    double zpp = sa*yp + ca*zp;
+	    int outside = xpp*xpp + ypp*ypp > 1.0;
+	    int infront = zpp > 0.0;
+	    mdp->svis = outside || infront;
+	}
+}
+
+/* set evis according to whether moon is geometrically visible from earth */
+static void
+moonEVis (MoonData md[M_NMOONS])
+{
+	int i;
+
+	for (i = 1; i < M_NMOONS; i++) {
+	    MoonData *mdp = &md[i];
+	    int outside = mdp->x*mdp->x + mdp->y*mdp->y > 1.0;
+	    int infront = mdp->z > 0.0;
+	    mdp->evis = outside || infront;
+	}
+}
+
+/* For RCS Only -- Do Not Edit */
+static char *rcsid[2] = {(char *)rcsid, "@(#) $RCSfile: marsmoon.c,v $ $Date: 2004-06-15 16:54:12 $ $Revision: 1.1 $ $Name: not supported by cvs2svn $"};
Index: /trunk/SophyaExt/XephemAstroLib/misc.c
===================================================================
--- /trunk/SophyaExt/XephemAstroLib/misc.c	(revision 2550)
+++ /trunk/SophyaExt/XephemAstroLib/misc.c	(revision 2551)
@@ -6,21 +6,12 @@
 #include <stdio.h>
 #include <math.h>
-
-#if defined(__STDC__)
 #include <stdlib.h>
 #include <string.h>
-#else
-extern double atof();
-#endif
-
-#include "P_.h"
+
 #include "astro.h"
-#include "circum.h"
 
 /* zero from loc for len bytes */
 void
-zero_mem (loc, len)
-void *loc;
-unsigned len;
+zero_mem (void *loc, unsigned len)
 {
 	(void) memset (loc, 0, len);
@@ -33,8 +24,5 @@
  */
 int
-tickmarks (min, max, numdiv, ticks)
-double min, max;
-int numdiv;
-double ticks[];
+tickmarks (double min, double max, int numdiv, double ticks[])
 {
         static int factor[] = { 1, 2, 5 };
@@ -47,5 +35,5 @@
         minscale = fabs(max - min);
         delta = minscale/numdiv;
-        for (n=0; n < sizeof(factor)/sizeof(factor[0]); n++) {
+        for (n=0; n < (int)(sizeof(factor)/sizeof(factor[0])); n++) {
 	    double scale;
 	    double x = delta/factor[n];
@@ -67,13 +55,15 @@
  */
 char *
-obj_description (op)
-Obj *op;
-{
-	static struct {
-	    char class;
+obj_description (Obj *op)
+{
+	typedef struct {
+	    char classcode;
 	    char *desc;
-	} fixed_class_map[] = {
+	} CC;
+
+#define	NFCM	((int)(sizeof(fixed_class_map)/sizeof(fixed_class_map[0])))
+	static CC fixed_class_map[] = {
 	    {'A', "Cluster of Galaxies"},
-	    {'B', "Binary Star"},
+	    {'B', "Binary System"},
 	    {'C', "Globular Cluster"},
 	    {'D', "Double Star"},
@@ -94,6 +84,25 @@
 	    {'U', "Cluster, with nebulosity"},
 	    {'V', "Variable Star"},
+	    {'Y', "Supernova"},
 	};
-#define	NFCM	(sizeof(fixed_class_map)/sizeof(fixed_class_map[0]))
+
+#define	NBCM	((int)(sizeof(binary_class_map)/sizeof(binary_class_map[0])))
+	static CC binary_class_map[] = {
+	    {'a', "Astrometric binary"},
+	    {'c', "Cataclysmic variable"},
+	    {'e', "Eclipsing binary"},
+	    {'x', "High-mass X-ray binary"},
+	    {'y', "Low-mass X-ray binary"},
+	    {'o', "Occultation binary"},
+	    {'s', "Spectroscopic binary"},
+	    {'t', "1-line spectral binary"},
+	    {'u', "2-line spectral binary"},
+	    {'v', "Spectrum binary"},
+	    {'b', "Visual binary"},
+	    {'d', "Visual binary, apparent"},
+	    {'q', "Visual binary, optical"},
+	    {'r', "Visual binary, physical"},
+	    {'p', "Exoplanet"},
+	};
 
 	switch (op->o_type) {
@@ -102,8 +111,8 @@
 		int i;
 		for (i = 0; i < NFCM; i++)
-		    if (fixed_class_map[i].class == op->f_class)
+		    if (fixed_class_map[i].classcode == op->f_class)
 			return (fixed_class_map[i].desc);
 	    }
-	    return (op->o_type == FIXED ? "Fixed" : "Field Star");
+	    return ("Fixed");
 	case PARABOLIC:
 	    return ("Solar - Parabolic");
@@ -112,11 +121,32 @@
 	case ELLIPTICAL:
 	    return ("Solar - Elliptical");
-	case PLANET:
-	    return ("Planet");
+	case BINARYSTAR:
+	    if (op->f_class) {
+		int i;
+		for (i = 0; i < NFCM; i++)
+		    if (binary_class_map[i].classcode == op->f_class)
+			return (binary_class_map[i].desc);
+	    }
+	    return ("Binary system");
+	case PLANET: {
+	    static char nsstr[16];
+	    static Obj *biop;
+
+	    if (op->pl_code == SUN)
+		return ("Star");
+	    if (op->pl_code == MOON)
+		return ("Moon of Earth");
+	    if (op->pl_moon == X_PLANET)
+		return ("Planet");
+	    if (!biop)
+		getBuiltInObjs (&biop);
+	    sprintf (nsstr, "Moon of %s", biop[op->pl_code].o_name);
+	    return (nsstr);
+	    }
 	case EARTHSAT:
 	    return ("Earth Sat");
 	default:
 	    printf ("obj_description: unknown type: 0x%x\n", op->o_type);
-	    exit (1);
+	    abort();
 	    return (NULL);	/* for lint */
 	}
@@ -126,7 +156,5 @@
  */
 void
-now_lst (np, lstp)
-Now *np;
-double *lstp;
+now_lst (Now *np, double *lstp)
 {
 	static double last_mjd = -23243, last_lng = 121212, last_lst;
@@ -156,8 +184,5 @@
  */
 void
-radec2ha (np, ra, dec, hap)
-Now *np;
-double ra, dec;
-double *hap;
+radec2ha (Now *np, double ra, double dec, double *hap)
 {
 	double ha, lst;
@@ -182,8 +207,8 @@
  */
 int
-lc (cx, cy, cw, x1, y1, x2, y2, sx1, sy1, sx2, sy2)
-int cx, cy, cw;			/* circle bounding box corner and width */
-int x1, y1, x2, y2;		/* line segment endpoints */
-int *sx1, *sy1, *sx2, *sy2;	/* segment inside the circle */
+lc (
+int cx, int cy, int cw,			/* circle bbox corner and width */
+int x1, int y1, int x2, int y2,		/* line segment endpoints */
+int *sx1, int *sy1, int *sx2, int *sy2)	/* segment inside the circle */
 {
 	int dx = x2 - x1;
@@ -240,10 +265,10 @@
  */
 void
-hg_mag (h, g, rp, rho, rsn, mp)
-double h, g;
-double rp;	/* sun-obj dist, AU */
-double rho;	/* earth-obj dist, AU */
-double rsn;	/* sun-earth dist, AU */
-double *mp;
+hg_mag (
+double h, double g,
+double rp,	/* sun-obj dist, AU */
+double rho,	/* earth-obj dist, AU */
+double rsn,	/* sun-earth dist, AU */
+double *mp)
 {
 	double psi_t, Psi_1, Psi_2, beta;
@@ -265,5 +290,6 @@
 	psi_t = pow (tb2, 1.22);
 	Psi_2 = exp(-1.87*psi_t);
-	*mp = h + 5.0*log10(rp*rho) - 2.5*log10((1-g)*Psi_1 + g*Psi_2);
+	*mp = h + 5.0*log10(rp*rho);
+	if (Psi_1 || Psi_2) *mp -= 2.5*log10((1-g)*Psi_1 + g*Psi_2);
 }
 
@@ -273,10 +299,10 @@
  */
 int
-magdiam (fmag, magstp, scale, mag, size)
-int fmag;	/* faintest mag */
-int magstp;	/* mag range per dot size */
-double scale;	/* rads per pixel */
-double mag;	/* magnitude */
-double size;	/* rads, or 0 */
+magdiam (
+int fmag,	/* faintest mag */
+int magstp,	/* mag range per dot size */
+double scale,	/* rads per pixel */
+double mag,	/* magnitude */
+double size)	/* rads, or 0 */
 {
 	int diam, sized;
@@ -295,9 +321,9 @@
  */
 void
-gk_mag (g, k, rp, rho, mp)
-double g, k;
-double rp;	/* sun-obj dist, AU */
-double rho;	/* earth-obj dist, AU */
-double *mp;
+gk_mag (
+double g, double k,
+double rp,	/* sun-obj dist, AU */
+double rho,	/* earth-obj dist, AU */
+double *mp)
 {
 	*mp = g + 5.0*log10(rho) + 2.5*k*log10(rp);
@@ -309,8 +335,7 @@
  */
 double
-atod (buf)
-char *buf;
-{
-	return (atof (buf));
+atod (char *buf)
+{
+	return (strtod (buf, NULL));
 }
 
@@ -331,11 +356,9 @@
  */
 void
-solve_sphere (A, b, cc, sc, cap, Bp)
-double A, b;
-double cc, sc;
-double *cap, *Bp;
+solve_sphere (double A, double b, double cc, double sc, double *cap, double *Bp)
 {
 	double cb = cos(b), sb = sin(b);
-	double cA = cos(A);
+	double sA, cA = cos(A);
+	double x, y;
 	double ca;
 	double B;
@@ -350,25 +373,8 @@
 	    return;
 
-	if (cc > .99999) {
-	    /* as c approaches 0, B approaches pi - A */
-	    B = PI - A;
-	} else if (cc < -.99999) {
-	    /* as c approaches PI, B approaches A */
-	    B = A;
-	} else {
-	    /* compute cB and sB and remove common factor of sa from quotient.
-	     * be careful where B causes atan to blow.
-	     */
-	    double sA = sin(A);
-	    double x, y;
-
-	    y = sA*sb*sc;
-	    x = cb - ca*cc;
-	
-	    if (fabs(x) < 1e-5)
-		B = y < 0 ? 3*PI/2 : PI/2;
-	    else
-		B = atan2 (y, x);
-	}
+	sA = sin(A);
+	y = sA*sb*sc;
+	x = cb - ca*cc;
+	B = y ? (x ? atan2(y,x) : (y>0 ? PI/2 : -PI/2)) : (x>=0 ? 0 : PI);
 
 	*Bp = B;
@@ -435,6 +441,5 @@
  */
 double
-delra (dra)
-double dra;
+delra (double dra)
 {
 	double fdra = fmod(fabs(dra), 2*PI);
@@ -449,6 +454,5 @@
  */
 int
-is_deepsky (op)
-Obj *op;
+is_deepsky (Obj *op)
 {
 	int deepsky = 0;
@@ -473,3 +477,3 @@
 
 /* For RCS Only -- Do Not Edit */
-static char *rcsid[2] = {(char *)rcsid, "@(#) $RCSfile: misc.c,v $ $Date: 2001-10-22 12:08:27 $ $Revision: 1.2 $ $Name: not supported by cvs2svn $"};
+static char *rcsid[2] = {(char *)rcsid, "@(#) $RCSfile: misc.c,v $ $Date: 2004-06-15 16:52:39 $ $Revision: 1.3 $ $Name: not supported by cvs2svn $"};
Index: /trunk/SophyaExt/XephemAstroLib/mjd.c
===================================================================
--- /trunk/SophyaExt/XephemAstroLib/mjd.c	(revision 2550)
+++ /trunk/SophyaExt/XephemAstroLib/mjd.c	(revision 2551)
@@ -4,5 +4,4 @@
 #include <math.h>
 
-#include "P_.h"
 #include "astro.h"
 
@@ -12,8 +11,5 @@
  */
 void
-cal_mjd (mn, dy, yr, mjd)
-int mn, yr;
-double dy;
-double *mjd;
+cal_mjd (int mn, double dy, int yr, double *mjp)
 {
 	static double last_mjd, last_dy;
@@ -23,5 +19,5 @@
 
 	if (mn == last_mn && yr == last_yr && dy == last_dy) {
-	    *mjd = last_mjd;
+	    *mjp = last_mjd;
 	    return;
 	}
@@ -49,22 +45,19 @@
 	d = (int)(30.6001*(m+1));
 
-	*mjd = b + c + d + dy - 0.5;
+	*mjp = b + c + d + dy - 0.5;
 
 	last_mn = mn;
 	last_dy = dy;
 	last_yr = yr;
-	last_mjd = *mjd;
+	last_mjd = *mjp;
 }
 
 /* given the modified Julian date (number of days elapsed since 1900 jan 0.5,),
- * mjd, return the calendar date in months, *mn, days, *dy, and years, *yr.
- */
-void
-mjd_cal (mjd, mn, dy, yr)
-double mjd;
-int *mn, *yr;
-double *dy;
-{
-	static double last_mjd, last_dy;
+ * mj, return the calendar date in months, *mn, days, *dy, and years, *yr.
+ */
+void
+mjd_cal (double mj, int *mn, double *dy, int *yr)
+{
+	static double last_mj, last_dy;
 	static int last_mn, last_yr;
 	double d, f;
@@ -74,5 +67,5 @@
 	 * 0 is noon the last day of 1899.
 	 */
-	if (mjd == 0.0) {
+	if (mj == 0.0) {
 	    *mn = 12;
 	    *dy = 31.5;
@@ -81,5 +74,5 @@
 	}
 
-	if (mjd == last_mjd) {
+	if (mj == last_mj) {
 	    *mn = last_mn;
 	    *yr = last_yr;
@@ -88,5 +81,5 @@
 	}
 
-	d = mjd + 0.5;
+	d = mj + 0.5;
 	i = floor(d);
 	f = d-i;
@@ -118,5 +111,5 @@
 	last_dy = *dy;
 	last_yr = *yr;
-	last_mjd = mjd;
+	last_mj = mj;
 }
 
@@ -126,7 +119,5 @@
  */
 int
-mjd_dow (mjd, dow)
-double mjd;
-int *dow;
+mjd_dow (double mj, int *dow)
 {
 	/* cal_mjd() uses Gregorian dates on or after Oct 15, 1582.
@@ -137,9 +128,9 @@
 	 * can not easily be accounted for from the cal_mjd() number...
 	 */
-	if (mjd < -53798.5) {
+	if (mj < -53798.5) {
 	    /* pre sept 14, 1752 too hard to correct |:-S */
 	    return (-1);
 	}
-	*dow = ((long)floor(mjd-.5) + 1) % 7;/* 1/1/1900 (mjd 0.5) is a Monday*/
+	*dow = ((long)floor(mj-.5) + 1) % 7;/* 1/1/1900 (mj 0.5) is a Monday*/
 	if (*dow < 0)
 	    *dow += 7;
@@ -149,6 +140,5 @@
 /* given a year, return whether it is a leap year */
 int
-isleapyear (y)
-int y;
+isleapyear (int y)
 {
 	return ((y%4==0 && y%100!=0) || y%400==0);
@@ -157,7 +147,5 @@
 /* given a mjd, return the the number of days in the month.  */
 void
-mjd_dpm (mjd, ndays)
-double mjd;
-int *ndays;
+mjd_dpm (double mj, int *ndays)
 {
 	static short dpm[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
@@ -165,5 +153,5 @@
 	double d;
 
-	mjd_cal (mjd, &m, &d, &y);
+	mjd_cal (mj, &m, &d, &y);
 	*ndays = (m==2 && isleapyear(y)) ? 29 : dpm[m-1];
 }
@@ -171,8 +159,5 @@
 /* given a mjd, return the year and number of days since 00:00 Jan 1 */
 void
-mjd_dayno (mjd, yr, dy)
-double mjd;
-int *yr;
-double *dy;
+mjd_dayno (double mj, int *yr, double *dy)
 {
 	double yrd;
@@ -180,5 +165,5 @@
 	int dpy;
 
-	mjd_year (mjd, &yrd);
+	mjd_year (mj, &yrd);
 	*yr = yri = (int)yrd;
 	dpy = isleapyear(yri) ? 366 : 365;
@@ -188,25 +173,23 @@
 /* given a mjd, return the year as a double. */
 void
-mjd_year (mjd, yr)
-double mjd;
-double *yr;
-{
-	static double last_mjd, last_yr;
+mjd_year (double mj, double *yr)
+{
+	static double last_mj, last_yr;
 	int m, y;
 	double d;
 	double e0, e1;	/* mjd of start of this year, start of next year */
 
-	if (mjd == last_mjd) {
+	if (mj == last_mj) {
 	    *yr = last_yr;
 	    return;
 	}
 
-	mjd_cal (mjd, &m, &d, &y);
+	mjd_cal (mj, &m, &d, &y);
 	if (y == -1) y = -2;
 	cal_mjd (1, 1.0, y, &e0);
 	cal_mjd (1, 1.0, y+1, &e1);
-	*yr = y + (mjd - e0)/(e1 - e0);
-
-	last_mjd = mjd;
+	*yr = y + (mj - e0)/(e1 - e0);
+
+	last_mj = mj;
 	last_yr = *yr;
 }
@@ -214,7 +197,5 @@
 /* given a decimal year, return mjd */
 void
-year_mjd (y, mjd)
-double y;
-double *mjd;
+year_mjd (double y, double *mjp)
 {
 	double e0, e1;	/* mjd of start of this year, start of next year */
@@ -224,11 +205,10 @@
 	cal_mjd (1, 1.0, yf, &e0);
 	cal_mjd (1, 1.0, yf+1, &e1);
-	*mjd = e0 + (y - yf)*(e1-e0);
+	*mjp = e0 + (y - yf)*(e1-e0);
 }
 
 /* round a time in days, *t, to the nearest second, IN PLACE. */
 void
-rnd_second (t)
-double *t;
+rnd_second (double *t)
 {
 	*t = floor(*t*SPD+0.5)/SPD;
@@ -237,16 +217,14 @@
 /* given an mjd, truncate it to the beginning of the whole day */
 double
-mjd_day(jd)
-double jd;
-{
-	return (floor(jd-0.5)+0.5);
+mjd_day(double mj)
+{
+	return (floor(mj-0.5)+0.5);
 }
 
 /* given an mjd, return the number of hours past midnight of the whole day */
 double
-mjd_hr(jd)
-double jd;
-{
-	return ((jd-mjd_day(jd))*24.0);
+mjd_hr(double mj)
+{
+	return ((mj-mjd_day(mj))*24.0);
 }
 
@@ -254,10 +232,25 @@
  */
 void
-range (v, r)
-double *v, r;
+range (double *v, double r)
 {
 	*v -= r*floor(*v/r);
 }
 
+/* insure 0 <= ra < 2PI and -PI/2 <= dec <= PI/2. if dec needs 
+ * complimenting, reflect ra too
+ */
+void
+radecrange (double *ra, double *dec)
+{
+	if (*dec < -PI/2) {
+	    *dec = -PI - *dec;
+	    *ra += PI;
+	} else if (*dec > PI/2) {
+	    *dec = PI - *dec;
+	    *ra += PI;
+	}
+	range (ra, 2*PI);
+}
+
 /* For RCS Only -- Do Not Edit */
-static char *rcsid[2] = {(char *)rcsid, "@(#) $RCSfile: mjd.c,v $ $Date: 2001-10-22 12:08:27 $ $Revision: 1.2 $ $Name: not supported by cvs2svn $"};
+static char *rcsid[2] = {(char *)rcsid, "@(#) $RCSfile: mjd.c,v $ $Date: 2004-06-15 16:52:39 $ $Revision: 1.3 $ $Name: not supported by cvs2svn $"};
Index: /trunk/SophyaExt/XephemAstroLib/moon.c
===================================================================
--- /trunk/SophyaExt/XephemAstroLib/moon.c	(revision 2550)
+++ /trunk/SophyaExt/XephemAstroLib/moon.c	(revision 2551)
@@ -62,10 +62,8 @@
  */
 
+#include <stdlib.h>
+#include <stdio.h>
 #include <math.h>
-#if defined(__STDC__)
-#include <stdlib.h>
-#endif
-
-#include "P_.h"
+
 #include "astro.h"
 
@@ -86,11 +84,11 @@
 };
 
-static double mods3600 P_((double x));
-static void mean_elements P_((double JED));
-static int sscc P_((int k, double arg, int n));
-static int g2plan P_((double J, struct plantbl *plan, double *pobj, int flag));
-static double g1plan P_((double J, struct plantbl *plan));
-static int gecmoon P_((double J, struct plantbl *lrtab,
-	struct plantbl *lattab, double *pobj));
+static double mods3600 (double x);
+static void mean_elements (double JED);
+static int sscc (int k, double arg, int n);
+static int g2plan (double J, struct plantbl *plan, double *pobj, int flag);
+static double g1plan (double J, struct plantbl *plan);
+static int gecmoon (double J, struct plantbl *lrtab,
+	struct plantbl *lattab, double *pobj);
 
 /* time points */
@@ -103,5 +101,4 @@
 static double Args[NARGS];
 static double LP_equinox;
-static double NF_arcsec;
 static double Ea_arcsec;
 static double pA_precession;
@@ -2832,6 +2829,5 @@
    answer in arc seconds  */
 static double
-mods3600(x)
-     double x;
+mods3600(double x)
 {
   double y;
@@ -2848,6 +2844,5 @@
 
 static void
-mean_elements (JED)
-     double JED;
+mean_elements (double JED)
 {
   double x, T, T2;
@@ -2932,5 +2927,4 @@
 	      - 7.5311878482337989e-04) * T /* F, t^3 */
 	     - 1.3117809789650071e+01) * T2; /* F, t^2 */
-  NF_arcsec = x;
   Args[10] = x;
 
@@ -3008,8 +3002,5 @@
  */
 static int 
-sscc (k, arg, n)
-     int k;
-     double arg;
-     int n;
+sscc (int k, double arg, int n)
 {
   double cu, su, cv, sv, s;
@@ -3040,9 +3031,5 @@
    of the same list of arguments.  */
 static int 
-g2plan (J, plan, pobj, flag)
-     double J;
-     struct plantbl *plan;
-     double pobj[];
-     int flag;
+g2plan (double J, struct plantbl *plan, double pobj[], int flag)
 {
   int i, j, k, m, k1, ip, np, nt;
@@ -3168,7 +3155,5 @@
 
 static double
-g1plan (J, plan)
-     double J;
-     struct plantbl *plan;
+g1plan (double J, struct plantbl *plan)
 {
   int i, j, k, m, k1, ip, np, nt;
@@ -3271,8 +3256,5 @@
  */
 static int 
-gecmoon (J, lrtab, lattab, pobj)
-     double J;
-     struct plantbl *lrtab, *lattab;
-     double pobj[];
+gecmoon (double J, struct plantbl *lrtab, struct plantbl *lattab, double pobj[])
 {
   double x;
@@ -3294,6 +3276,6 @@
 /*********** end stephen moshier's moon code ****************/
 
-static void moon_fast P_((double mjd, double *lam, double *bet,
-	double *hp, double *msp, double *mdp));
+static void moon_fast (double mj, double *lam, double *bet,
+	double *hp, double *msp, double *mdp);
 
 /* previous version (elwood):
@@ -3309,8 +3291,6 @@
  */
 static void
-moon_fast (mjd, lam, bet, hp, msp, mdp)
-double mjd;
-double *lam, *bet, *hp;
-double *msp, *mdp;
+moon_fast (double mj, double *lam, double *bet, double *hp, double *msp,
+double *mdp)
 {
 	double t, t2;
@@ -3324,18 +3304,18 @@
 	double m1, m2, m3, m4, m5, m6;
 
-	t = mjd/36525.;
+	t = mj/36525.;
 	t2 = t*t;
 
-	m1 = mjd/27.32158213;
+	m1 = mj/27.32158213;
 	m1 = 360.0*(m1-(long)m1);
-	m2 = mjd/365.2596407;
+	m2 = mj/365.2596407;
 	m2 = 360.0*(m2-(long)m2);
-	m3 = mjd/27.55455094;
+	m3 = mj/27.55455094;
 	m3 = 360.0*(m3-(long)m3);
-	m4 = mjd/29.53058868;
+	m4 = mj/29.53058868;
 	m4 = 360.0*(m4-(long)m4);
-	m5 = mjd/27.21222039;
+	m5 = mj/27.21222039;
 	m5 = 360.0*(m5-(long)m5);
-	m6 = mjd/6798.363307;
+	m6 = mj/6798.363307;
 	m6 = 360.0*(m6-(long)m6);
 
@@ -3456,18 +3436,16 @@
  */
 void
-moon (mjd, lam, bet, rho, msp, mdp)
-double mjd;
-double *lam, *bet, *rho;
-double *msp, *mdp;
+moon (double mj, double *lam, double *bet, double *rho, double *msp,
+double *mdp)
 {
 	double pobj[3], dt;
 	double hp;
 
-	if (mjd >= MOSHIER_BEGIN && mjd <= MOSHIER_END) {
+	if (mj >= MOSHIER_BEGIN && mj <= MOSHIER_END) {
 		/* retard for light time */
-		moon_fast (mjd, lam, bet, &hp, msp, mdp);
+		moon_fast (mj, lam, bet, &hp, msp, mdp);
 		*rho = EarthRadius/AUKM/sin(hp);
 		dt = *rho * 5.7755183e-3;       /* speed of light in a.u/day */
-		gecmoon(mjd + MJD0 - dt, &moonlr, &moonlat, pobj);
+		gecmoon(mj + MJD0 - dt, &moonlr, &moonlat, pobj);
 
 		*lam = pobj[0];
@@ -3478,5 +3456,5 @@
 		*mdp = STR * Args[12];
 	} else {
-		moon_fast (mjd, lam, bet, &hp, msp, mdp);
+		moon_fast (mj, lam, bet, &hp, msp, mdp);
 		*rho = EarthRadius/AUKM/sin(hp);
 
@@ -3485,3 +3463,3 @@
 
 /* For RCS Only -- Do Not Edit */
-static char *rcsid[2] = {(char *)rcsid, "@(#) $RCSfile: moon.c,v $ $Date: 2001-10-22 12:08:27 $ $Revision: 1.2 $ $Name: not supported by cvs2svn $"};
+static char *rcsid[2] = {(char *)rcsid, "@(#) $RCSfile: moon.c,v $ $Date: 2004-06-15 16:52:39 $ $Revision: 1.3 $ $Name: not supported by cvs2svn $"};
Index: /trunk/SophyaExt/XephemAstroLib/mooncolong.c
===================================================================
--- /trunk/SophyaExt/XephemAstroLib/mooncolong.c	(revision 2550)
+++ /trunk/SophyaExt/XephemAstroLib/mooncolong.c	(revision 2551)
@@ -3,19 +3,16 @@
 
 #include <stdio.h>
+#include <stdlib.h>
 #include <math.h>
-#if defined(__STDC__)
-#include <stdlib.h>
-#endif
-
-#include "P_.h"
+
 #include "astro.h"
 
-static void Librations P_((double RAD, double LAMH, double BH, double OM,
-    double F, double L, double L1, double *L0, double *B0));
-static void Moon P_((double RAD, double T, double T2, double LAM0, double R,
+static void Librations (double RAD, double LAMH, double BH, double OM,
+    double F, double L, double L1, double *L0, double *B0);
+static void Moon (double RAD, double T, double T2, double LAM0, double R,
     double M, double *F, double *L1, double *OM, double *LAM, double *B,
-    double *DR, double *LAMH, double *BH));
-static void Sun P_((double RAD, double T, double T2, double *L, double *M,
-    double *R, double *LAM0));
+    double *DR, double *LAMH, double *BH);
+static void Sun (double RAD, double T, double T2, double *L, double *M,
+    double *R, double *LAM0);
 
 /* given a Julian date and a lunar location, find selenographic colongitude of
@@ -26,11 +23,12 @@
  */
 void
-moon_colong (jd, lt, lg, cp, kp, ap, sp)
-double jd;	/* jd */
-double lt, lg;	/* lat/long of location on moon, rads +N +E */
-double *cp;	/* selenographic colongitude (-lng of rising sun), rads */
-double *kp;	/* illuminated fraction of surface from Earth */
-double *ap;	/* sun altitude at location, rads */
-double *sp;	/* lunar latitude of subsolar point, rads */
+moon_colong (
+double jd,	/* jd */
+double lt,	/* lat of location on moon, rads +N +E */
+double lg,	/* long of location on moon, rads +N +E */
+double *cp,	/* selenographic colongitude (-lng of rising sun), rads */
+double *kp,	/* illuminated fraction of surface from Earth */
+double *ap,	/* sun altitude at location, rads */
+double *sp)	/* lunar latitude of subsolar point, rads */
 {
 	double RAD = .0174533;
@@ -89,14 +87,6 @@
 
 static void
-Librations (RAD, LAMH, BH, OM, F, L, L1, L0, B0)
-double RAD;
-double LAMH;
-double BH;
-double OM;
-double F;
-double L;
-double L1;
-double *L0;
-double *B0;
+Librations (double RAD, double LAMH, double BH, double OM, double F,
+double L, double L1, double *L0, double *B0)
 { 
 	double I, PSI, W, NUM, DEN, A, TEMP;
@@ -123,19 +113,7 @@
 
 static void
-Moon (RAD, T, T2, LAM0, R, M, F, L1, OM, LAM, B, DR, LAMH, BH)
-double RAD;
-double T;
-double T2;
-double LAM0;
-double R;
-double M;
-double *F;
-double *L1;
-double *OM;
-double *LAM;
-double *B;
-double *DR;
-double *LAMH;
-double *BH;
+Moon (double RAD, double T, double T2, double LAM0, double R, double M,
+double *F, double *L1, double *OM, double *LAM, double *B, double *DR,
+double *LAMH, double *BH)
 {
 	double T3, M1, D2, SUMR, SUML, DIST;
@@ -175,12 +153,6 @@
 
 static void
-Sun (RAD, T, T2, L, M, R, LAM0)
-double RAD;
-double T;
-double T2;
-double *L;
-double *M;
-double *R;
-double *LAM0;
+Sun (double RAD, double T, double T2, double *L, double *M, double *R,
+double *LAM0)
 {
 	double T3, C, V, E, THETA, OM;
@@ -238,5 +210,5 @@
 	if (ac != 2) {
 	    fprintf (stderr, "%s: JD\n", av[0]);
-	    exit (1);
+	    abort();
 	}
 
@@ -262,3 +234,3 @@
 
 /* For RCS Only -- Do Not Edit */
-static char *rcsid[2] = {(char *)rcsid, "@(#) $RCSfile: mooncolong.c,v $ $Date: 2001-10-22 12:08:27 $ $Revision: 1.2 $ $Name: not supported by cvs2svn $"};
+static char *rcsid[2] = {(char *)rcsid, "@(#) $RCSfile: mooncolong.c,v $ $Date: 2004-06-15 16:52:39 $ $Revision: 1.3 $ $Name: not supported by cvs2svn $"};
Index: /trunk/SophyaExt/XephemAstroLib/nutation.c
===================================================================
--- /trunk/SophyaExt/XephemAstroLib/nutation.c	(revision 2550)
+++ /trunk/SophyaExt/XephemAstroLib/nutation.c	(revision 2551)
@@ -3,7 +3,7 @@
  * (given to 0.001") EXACTLY over 750 days (1995 and 1996)
  */
+#include <stdio.h>
 #include <math.h>
 
-#include "P_.h"
 #include "astro.h"
 
@@ -268,14 +268,14 @@
 };
 
-/* given the modified JD, mjd, find the nutation in obliquity, *deps, and
+/* given the modified JD, mj, find the nutation in obliquity, *deps, and
  * the nutation in longitude, *dpsi, each in radians.
  */
 void
-nutation (mjd, deps, dpsi)
-double mjd;
-double *deps;	/* on input:  precision parameter in arc seconds */
-double *dpsi;
+nutation (
+double mj,
+double *deps,	/* on input:  precision parameter in arc seconds */
+double *dpsi)
 {
-	static double lastmjd = -10000, lastdeps, lastdpsi;
+	static double lastmj = -10000, lastdeps, lastdpsi;
 	double T, T2, T3, T10;			/* jul cent since J2000 */
 	double prec;				/* series precis in arc sec */
@@ -287,5 +287,5 @@
 			 */
 
-	if (mjd == lastmjd) {
+	if (mj == lastmj) {
 	    *deps = lastdeps;
 	    *dpsi = lastdpsi;
@@ -304,5 +304,5 @@
 	prec *= NUT_SCALE/10;
 
-	T = (mjd - J2000)/36525.;
+	T = (mj - J2000)/36525.;
 	T2 = T * T;
 	T3 = T2 * T;
@@ -362,26 +362,25 @@
 	lastdeps = degrad(lastdeps/3600./NUT_SCALE);
 
-	lastmjd = mjd;
+	lastmj = mj;
 	*deps = lastdeps;
 	*dpsi = lastdpsi;
 }
 
-/* given the modified JD, mjd, correct, IN PLACE, the right ascension *ra
+/* given the modified JD, mj, correct, IN PLACE, the right ascension *ra
  * and declination *dec (both in radians) for nutation.
  */
 void
-nut_eq (mjd, ra, dec)
-double mjd, *ra, *dec;
+nut_eq (double mj, double *ra, double *dec)
 {
-	static double lastmjd = -10000;
+	static double lastmj = -10000;
 	static double a[3][3];		/* rotation matrix */
 	double xold, yold, zold, x, y, z;
 
-	if (mjd != lastmjd) {
+	if (mj != lastmj) {
 	    double epsilon, dpsi, deps;
 	    double se, ce, sp, cp, sede, cede;
 
-	    obliquity(mjd, &epsilon);
-	    nutation(mjd, &deps, &dpsi);
+	    obliquity(mj, &epsilon);
+	    nutation(mj, &deps, &dpsi);
 
 	    /* the rotation matrix a applies the nutation correction to
@@ -428,5 +427,5 @@
 	    a[2][2] = sede*cp*se+cede*ce;
 
-	    lastmjd = mjd;
+	    lastmj = mj;
 	}
 
@@ -440,3 +439,3 @@
 
 /* For RCS Only -- Do Not Edit */
-static char *rcsid[2] = {(char *)rcsid, "@(#) $RCSfile: nutation.c,v $ $Date: 2001-10-22 12:08:27 $ $Revision: 1.2 $ $Name: not supported by cvs2svn $"};
+static char *rcsid[2] = {(char *)rcsid, "@(#) $RCSfile: nutation.c,v $ $Date: 2004-06-15 16:52:39 $ $Revision: 1.3 $ $Name: not supported by cvs2svn $"};
